package com.bjsxt.springbootjdbc.dao.impl;

import com.bjsxt.springbootjdbc.dao.UserDao;
import com.bjsxt.springbootjdbc.pojo.User;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.List;

/**
 *
 */
@Repository
public class UserDaoImpl implements UserDao {
    @Autowired
    JdbcTemplate jdbcTemplate;

    @Override
    public void insertUser(User user) {
        String sql = "insert into user(username,usersex) values(?,?)";
        this.jdbcTemplate.update(sql, user.getUsername(), user.getUsersex());
    }

    @Override
    public List<User> findAllUser() {
        String sql = "select * from user";
         return this.jdbcTemplate.query(sql, new RowMapper<User>() {
            /**
             * 结果集的映射
             *
             * @param rs
             * @param rowNum
             * @return
             * @throws SQLException
             */
            @Override
            public User mapRow(ResultSet rs, int rowNum) throws SQLException {
                User user = new User();
                user.setUserid(rs.getInt("userid"));
                user.setUsername(rs.getString("username"));
                user.setUsersex(rs.getString("usersex"));
                return user;
            }
        });
    }

    @Override
    public User preUpdateUser() {
        return null;
    }
}

